﻿using System;
using System.Configuration;

namespace WebConfigPractice.ServiceCode
{
    public class DefaultValuesConfigSection : ConfigurationSection
    {
        [ConfigurationProperty("email")]
        [CallbackValidator(CallbackMethodName = "ValidateConfigEmail", Type = typeof(DefaultValuesConfigSection))]
        public string Email
        {
            get { return (string)this["email"]; }
            set { this["email"] = value; }
        }

        [ConfigurationProperty("city", IsRequired = true)]
        public string City
        {
            get { return (string)this["city"]; }
            set { this["city"] = value; }
        }

        [ConfigurationProperty("timeZoneShift", DefaultValue = 5)]
        public int TimeZoneShift
        {
            get { return (int)this["timeZoneShift"]; }
            set { this["timeZoneShift"] = value; }
        }

        public static void ValidateConfigEmail(object val)
        {
            if (string.IsNullOrEmpty((string) val))
                return;
            if (!((string)val).ToLower().Contains("admin"))
                throw new Exception("Указан невалидный Email");
        }
    }
}